#!/bin/bash
proj_dir=/home/dbfrontier/apps/Monitor/Apps
export X509_USER_CERT=/home/dbfrontier/certs/hostcert.pem
export X509_USER_KEY=/home/dbfrontier/certs/hostkey.pem
export X509_USER_PROXY=$proj_dir/proxy
. /afs/cern.ch/cms/LCG/LCG-2/UI/cms_ui_env.sh 2>&1 1>& /dev/null < /dev/null
myproxy-get-delegation -s myproxy.cern.ch -d -a $X509_USER_PROXY -k 'proxy for dbfrontier' -o $X509_USER_PROXY
date >> $proj_dir/proxy.log
grid-proxy-info -f $X509_USER_PROXY >> $proj_dir/proxy.log

