#!/usr/bin/python
import httplib
import urllib2

class GetCICFeed:

        def __init__(self):
                self.data = []
                feedname = "CMS Downtime Notification"
                url="http://cic.gridops.org/downtime_rss.php?id_sub=1641"
                self.feedinfo = {feedname:url}
		self.feed_data = None

        def feeddata (self, feedname):
                feedaddress = self.feedinfo[feedname]
                return feedaddress

        def links (self, address):
                file_request = urllib2.Request(address)
                file_opener = urllib2.build_opener()
		try:
	                file_open = file_opener.open(file_request)
		except:
			raise Exception("urlopen error")
#       	for item in dir(file_open):
#  		        print item
#   	         	print dir(getattr(file_open,item))
#       	message = file_open.info()
#	        print message
                file_feed = file_open.read()
		self.feed_data = file_feed
		if file_feed == None: 
			raise Exception (' failed to read out from CIC RSS ')
#        	print dir(file_feed)
                return file_feed
	def writedown(self,filename):
		if self.feed_data != None:
			try:
				file = open(filename,'w')
				try:
					file.write(self.feed_data)
				finally:
					file.close()
			except IOError:
				raise Exception (' failed to write down in local file ')
		else: pass
	
if __name__ == "__main__":
	feed = GetCICFeed()
	feedname = "CMS Downtime Notification"
	feedurl = feed.feeddata(feedname)
	import traceback
	feedbody = None
	try:
		feedbody = feed.links(feedurl)
	except Exception:
		print "failed in get CIC feed"
		print traceback.print_exc()
	if feedbody : 
		print "OK"
	else: print "Empty"
	try:
		rss_feed = 'Monit/cic.rss'
		feed.writedown(rss_feed)
		
	except Exception:
		print "failed in write down feed"
		print traceback.print_exc()

