#!/usr/bin/python
import os
from xml.dom.ext.reader import Sax2
reader = Sax2.Reader()
from xml.dom.ext import PrettyPrint

#from datetime import datetime, date, time
import time
#

from ical import Event

class RssParser:
        def __init__(self,feed,appdir):
                self.feed_format(feed)		
                self.feeddom = reader.fromString(self.feed)
                self.appdir=appdir
                self.todaylist = []
	def feed_format(self,feed):
		self.feed = feed.replace('&','and')
        def output(self):
                outputfile = os.path.join(self.appdir,'Monit/cmsdowntime.rss')
                try:
			file_output= open(outputfile,'w')
			try:
			        PrettyPrint(self.feeddom,file_output)
			finally:
		                file_output.close()
		except IOError:
			raise Exception("IOError at def output")
#        def addTodayEvent(self,event):
#                self.todayList.append(event)
#        def cleanTodayList(self):
#                self.todayList=[]
        def parser(self,sitedb,ical,ical_t0_t1=None,ical_t2=None,ical_t3=None):#,file):
		if len(self.feeddom.getElementsByTagName('item')) <= 1:
			raise Exception ("rss feed empty")
                for node in self.feeddom.getElementsByTagName('item'):
                        self.parseItem(node,sitedb,ical,ical_t0_t1,ical_t2,ical_t3)#,file)
        def deleteItem(self,node):
                node.parentNode.removeChild(node)
        def parseItem(self,node,sitedb,ical,ical_t0_t1,ical_t2,ical_t3):#,file):
#	general check for all tags.
		tag_list = ('downtime:site','downtime:start','downtime:end','title','link','description','pubDate','downtime:severity')	
		for tag in tag_list:
			if node.getElementsByTagName(tag) == None or len(node.getElementsByTagName(tag)) == 0:
				print " tag is None %s" % tag
				return False
			if node.getElementsByTagName(tag)[0].firstChild == None:
				print "tag is empty %s" % tag
				return False
#       downtime:node can be empty

#       parse ce/se name
                element_list = node.getElementsByTagName('downtime:node')
                confirm = False
#       parse SiteName
                site=node.getElementsByTagName('downtime:site')[0].firstChild
                sam_name=site.data
                sam_name_lower=sam_name.lower()
#       print sam_name_lower
                cms_name=sitedb.name_convert(sam_name_lower)
#	location info
		location = ""
#	nodes showing in location
		nodes_location = []
                if element_list.length != 0:
#			servicelist in samdb
			servicelist_samdb = sitedb.get_services(sam_name_lower)
#			servicelist in rss feed
			servicelist = {}
                        for element in element_list:
				
                                if element.hasChildNodes():
                                        site_node = element.firstChild
#                       if site_node.nodeType == site_node.TEXT_NODE:
                                        element_name = site_node.data
                                        element_name_lower = element_name.lower()
#                                        file.write("%s\n"%element_name)

					service = sitedb.search_node(element_name_lower,sam_name_lower)
#					print element_name_lower,sam_name_lower,service
					if service != None:
						if not servicelist.has_key(service): 
							servicelist[service] = 1
						else:
							servicelist[service] = servicelist[service] + 1
#					add new node to nodes_location list
						if nodes_location.count(element_name_lower) == 0:
							nodes_location.append(element_name_lower)
#			create location info
			for service in servicelist.keys():
#				print service, servicelist[service],servicelist_samdb[service]
				location = location + " %s: %d/%d,"%(service,servicelist[service],servicelist_samdb[service])

#			for CE or SE if all in rss feed then will be a full downtime, confirm = True
				if service == 'ce' and servicelist[service] == servicelist_samdb[service] : 
					confirm = True
				if service == 'srmv2' and servicelist[service] == servicelist_samdb[service] :
					confirm = True
								
#			print location
#                       cut off the name suffix _
#                                        ele = element_name_lower.split('_')[0]
#                                        if sitedb.element_exists(ele):
#                                                confirm = True
		

#       print cms_name
                if cms_name == None:
#               print "deleteItem"
                        self.deleteItem(node)
                        return False
                else:
                        site.deleteData(0,len(sam_name))
                        site.appendData(cms_name)
#       parse Title
                        title = node.getElementsByTagName('title')[0].firstChild
                        title_origin = title.data
                        title_pics = title_origin.split(' ')
                        title_type = title_pics[0]
                        if title_type == 'ANNOUNCEMENT':
                                title_pics[2] = cms_name + '/'
                                title_new = " ".join(title_pics)
                        elif title_type == 'START' or title_type == 'END':
                                title_pics[2] = cms_name + '/'
                                title_new = " ".join(title_pics)
                        else: return False
                        if not confirm: title_new= ' # ' + title_new
                        title.deleteData(0,len(title_origin))
                        title.appendData(title_new)
#                       if title_type == 'ANNOUNCEMENT':
                        title_new=" ".join(title_pics[2:])
                        if not confirm: title_new= ' # ' + title_new
                        #       parse Ical feed
                        #       URI,dtstart,dtend,dtstamp,summary,description
                        URI=node.getElementsByTagName('link')[0].firstChild.data
                        start=node.getElementsByTagName('downtime:start')[0].firstChild.data
#                        start=time.strptime(start,"%d-%m-%Y %H:%M")
			start=time.strptime(start,"%Y-%m-%d %H:%M")
                        end=node.getElementsByTagName('downtime:end')[0].firstChild.data
#                        end=time.strptime(end,"%d-%m-%Y %H:%M")
			end=time.strptime(end,"%Y-%m-%d %H:%M")
                        stamp=node.getElementsByTagName('pubDate')[0].firstChild.data
                        stamp=time.strptime(str(stamp),"%a, %d %b %Y %H:%M:%S %Z")
                        description=node.getElementsByTagName('description')[0].firstChild.data
			severity = node.getElementsByTagName('downtime:severity')[0].firstChild.data
                        summary=title_new +" " + severity
			LINK = " <a href=\"%s\">LINK</a>"%URI
			location = location +" "+ " ".join(nodes_location) 
			description = description + LINK
                        new_event = Event(URI,start,end,stamp,summary,description,location)
                        if ical.hasEvent(new_event): 
#                                print "Ignore:%s"%new_event.URI
                                pass
                        else:
#                                print "Added:%s"%new_event.URI
                                ical.addEvent(new_event)
                                if cms_name[0:2] == 'T3' and ical_t3 != None: 
                                        ical_t3.addEvent(new_event)
                                elif cms_name[0:2] == 'T2' and ical_t2 != None:
                                        ical_t2.addEvent(new_event)
                                elif ical_t0_t1 != None:
                                        ical_t0_t1.addEvent(new_event)


#                               today = datetime.today()
#                               startdate = date(start[0],start[1],start[2])
#                               if today != startdate: pass
#                               else:


                        return True
if __name__ == "__main__":
	import traceback
	appdir = os.getenv('APP_DIR')
	from getCICFeed import GetCICFeed
	feed = GetCICFeed()
	feedname = "CMS Downtime Notification"
	feedurl = feed.feeddata(feedname)
	from ical import Ical
        ical_file = os.path.join(appdir,"Monit/cmsdowntime_All.ics")
        ical = Ical(ical_file)
	from samdb_dict import SiteDB_dict
	dict = SiteDB_dict()
	try:
#		feed_data = feed.links(feedurl)
		feed_file = open('Monit/cic.rss')
		feed_data = feed_file.read()
		feed_file.close()

		test_parser = RssParser(feed_data,appdir)
		test_parser.output()

		dict.fill_dict(appdir)
	        test_parser.parser(dict,ical)#,ical_t0_t1,ical_t2,ical_t3)#,file)
	        ical.publish()
	except Exception:
		print "Failed "
		print traceback.print_exc()
		print "end of Failed info"
	

