#!/usr/bin/python
import os
from xml.dom import minidom

class SiteDB_dict:
        def __init__(self):
                self.name_dict={}
                self.ce_dict={}
                self.se_dict={}
        def fill_dict(self,appdir):
                filename1 = os.path.join(appdir,'Monit/name_convert.xml')
                filename2 = os.path.join(appdir,'Monit/ce_convert.xml')
                filename3 = os.path.join(appdir,'Monit/se_convert.xml')
                name_file = open(filename1,'r')
                ce_file = open(filename2,'r')
                se_file = open(filename3,'r')
                name_convert_xml=name_file.read()
                ce_convert_xml=ce_file.read()
                se_convert_xml=se_file.read()
                self.name_dict=self.parseoutput(name_convert_xml,True)
                self.ce_dict=self.parseoutput(ce_convert_xml)
                self.se_dict=self.parseoutput(se_convert_xml)
        def parseoutput(self,data, reverse=False):
                """XML parser for sitedb report"""
                dom  = minidom.parseString(data)
                datalist = {}
                nodes = dom.getElementsByTagName('item')

                for node in nodes:
#                       print "each site"
#                       for child in node.childNodes:
#                               print "each node"
#                               print child
                        if reverse:
                                keynode = node.childNodes[3]
                                valnode = node.childNodes[1]
                        else:
                                keynode = node.childNodes[1]
                                valnode = node.childNodes[3]
#                       print valnode
                        keydata = keynode.firstChild.data.lower()
                        valdata = valnode.firstChild.data
                                
                        datalist[keydata]=valdata
                return datalist 
        def name_convert(self,sam_name):
#               print sam_name  
#               print len(name_dict)
                if self.name_dict.has_key(sam_name):
#               print sam_name +'='+name_dict[sam_name]
                        return self.name_dict[sam_name]
                else: return None
        def element_exists(self,ele):
                if self.ce_dict.has_key(ele):
                        return True
                elif self.se_dict.has_key(ele):
                        return True
                else: return False

if __name__ == "__main__":
        dict = SiteDB_dict()
	appdir = os.getenv('APP_DIR')
        dict.fill_dict(appdir)

