#!/usr/bin/perl -w
use strict;
my @servers = qw( cmsfrontier1 cmsfrontier2 cmsfrontier3);
#my @servers = qw(cmsfrontier3);
my $server = '';
my $dir = '/afs/cern.ch/user/l/liangd/public/Command/Frontier_t0';
my $logdir = '/data/dbs_logs/Frontier_t0';
my $cmd = "$dir/Frontier_t0.py";
my $results='';
my $tag=`date +%Y%m%d%H`;
open (FILE, ">$logdir/t0check") or die "an error occured while trying to open file";
$results = $results . "<h2>Check the User who is at CERN using Frontier by pass T0</h2>";
$results = $results . "<h3> Check date: $tag </h3>" . "\n";
foreach $server (@servers){
    $results = $results . "<h3> $server </h3>" . "\n";
#	print $server,"\n";
#    system "ssh $server \"$cmd\" ";
	$results = $results . "<pre>"; 
	$results= $results . `/usr/local/bin/ssh dbfrontier\@$server \"$cmd\"`;
	$results = $results . "</pre>";
}
#print $results;
print FILE $results;
close(FILE) or die "an error occured while trying to close file";
#echo $results >> $dir/$tag ;
#open MAIL, "|mail -s 'frontier_t0_cern' liangd\@cern.ch";
#print MAIL $results;
#close MAIL; 
